/*$
Copyright (c) 2015, Azel
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
$*/

/******************************
 * HTTP リクエストパーサー
 ******************************/

typedef struct
{
	char *buf,
		*bodytop;   //ボディ部分の先頭
	uint32_t size;
}HTTPBuf;

typedef struct
{
	char *path,			//リクエスト URI (バッファ内の位置)
		*url_param;		//? 以降のパラメータ部分
	const char *status_reason;	//レスポンスのステータス理由

	int statuscode,		//レスポンスのステータスコード
		method,			//HTTP メソッド
		version;		//HTTP バージョン
	uint8_t connection_close;	//接続を閉じるか
}HTTPRequest;


enum
{
	HTTP_METHOD_GET,
	HTTP_METHOD_HEAD,
	HTTP_METHOD_POST
};

enum
{
	HTTP_VERSION_UNKNOWN,
	HTTP_VERSION_10,
	HTTP_VERSION_11
};

enum
{
	HTTP_STATUSCODE_NOT_MODIFIED = 304,
	HTTP_STATUSCODE_BAD_REQUEST = 400,
	HTTP_STATUSCODE_NOT_FOUND = 404,
	HTTP_STATUSCODE_INTERNAL_SERVER_ERROR = 500,
	HTTP_STATUSCODE_NOT_IMPLEMENTED = 501
};


void parser_http_request(HTTPBuf *buf,HTTPRequest *req,char *modified_time);
void set_http_status_code(HTTPRequest *req,int code);
